using System.Collections.Generic;

using LiteDB;

using skydiveLogs_api.Domain;
using skydiveLogs_api.DomainService.Repositories;
using skydiveLogs_api.Infrastructure.Interfaces;


namespace skydiveLogs_api.Infrastructure
{
    public class GearRepository : IGearRepository
    {
        public GearRepository(IDataProvider dataProvider)
        {
            _dataProvider = dataProvider;
            _col = _dataProvider.CollOfGear;
        }

        public IEnumerable<Gear> GetAll()
        {
            throw new System.NotImplementedException();
        }

        public IEnumerable<Gear> GetAll(User user)
        {
            return _col.Include(x => x.User)
                       .Query()
                       .Where(j => j.User.Id == user.Id)
                       .ToList();
        }

        public Gear GetById(int id)
        {
            return _col.FindById(new BsonValue(id));
        }

        public bool Update(Gear updatedGear)
        {
            return _col.Update(updatedGear);
        }

        public bool Add(Gear newGear)
        {
            var result = true;

            try
            {
                _col.Insert(newGear);
            }
            catch
            {
                result = false;
            }

            return result;
        }

        private readonly IDataProvider _dataProvider;

        private readonly ILiteCollection<Gear> _col;
    }
}
